/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.datei.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="DATEI_EXPORT.All",
     query="SELECT o FROM DateiExport o",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="DATEI_EXPORT.DateiExportArtAndWahlOrderBeiErstellungszeitpunktDesc",
     query="SELECT OBJECT(o) FROM DateiExport o WHERE o.dateiArt=?1 AND o.datei.wahl=?2 ORDER BY o.datei.erstellungszeitpunkt DESC",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="DATEI_EXPORT.DateiExportArtAndWahlterminOrderBeiErstellungszeitpunktDesc",
     query="SELECT OBJECT(o) FROM DateiExport o WHERE o.dateiArt=?1 AND o.datei.wahltermin=?2 ORDER BY o.datei.erstellungszeitpunkt DESC",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="DATEI_EXPORT.DateiExportArtOrderBeiErstellungszeitpunktDesc",
     query="SELECT OBJECT(o) FROM DateiExport o WHERE o.datei.mandant=?1 AND o.dateiArt=?2 ORDER BY o.datei.erstellungszeitpunkt DESC",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="DATEI_EXPORT.Datei",
     query="SELECT o FROM DateiExport o WHERE o.datei = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "DATEI_EXPORT")
// @javax.persistence.IdClass(DateiExportPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class DateiExport
extends AbstractDateiExport
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public DateiExport() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public DateiExport(DateiExport original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "datei_export_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "DateiExport")
    @javax.persistence.TableGenerator(name = "DateiExport", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "DateiExport", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient DateiExportPK pkCache;

  @Override
  public DateiExportPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new DateiExportPK(getId());
    }

    return pkCache;
  }

  public static <E extends DateiExport> java.util.Map<DateiExportPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<DateiExportPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends DateiExport> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;


  public void resetAttributeChanged() {
        hasChangedDateiArt = false;
  
      hasChangedDatei = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "DATEI_ART", nullable = DateiExportConstants.DATEI_ART_NULLABLE)
    
  protected de.ivu.elect.business.exchange.entity.DateiExportArt dateiArt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedDateiArt = false;

  public boolean hasChangedDateiArt(){
    return hasChangedDateiArt;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertDateiArt = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.exchange.entity.DateiExportArt wertNachLadenDateiArt;
  
  /**
   * 
   *
   * getter for DATEI_EXPORT.DATEI_ART
   */
    @Override   public  de.ivu.elect.business.exchange.entity.DateiExportArt getDateiArt() {
        return dateiArt;
      }

  /**
   * 
   *
   * setter for DATEI_EXPORT.DATEI_ART
   *
   * @param dateiArt
   */
  @Override   public void setDateiArt( de.ivu.elect.business.exchange.entity.DateiExportArt dateiArt) {

       resetTkCache();
                  de.ivu.elect.business.exchange.entity.DateiExportArt dateiArtInternal = dateiArt;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.dateiArt
      , dateiArtInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedDateiArt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("dateiArt");
      }


             if (!isSeitLadenVeraendertDateiArt) {
          isSeitLadenVeraendertDateiArt = thisAttributChanged;
         if (isSeitLadenVeraendertDateiArt){
           wertNachLadenDateiArt=this.dateiArt;
         }
       }
      

       this.dateiArt = dateiArtInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Datei
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "DATEI_ID", referencedColumnName="DATEI_ID"))
  protected de.ivu.elect.business.datei.entity.Datei datei;

  /**
   * 
   */
  @Override
  public void setDatei( de.ivu.elect.business.datei.entity.Datei datei){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.datei
    , datei);

    attributeChanged |= thisAttributChanged;

    hasChangedDatei |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("datei");
    }

    this.datei = datei;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.datei.entity.Datei getDatei(){
    return this.datei;
  }

  @javax.persistence.Transient
  protected boolean hasChangedDatei = false;

  public boolean hasChangedDatei(){
    return hasChangedDatei;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("DateiExport:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(DateiExport other){
                             other.dateiArt = this.dateiArt;
           
  other.setDatei(this.getDatei());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(DateiExport.class)){
        copyEntityAttributesUsingSetter((DateiExport) other.castTo(DateiExport.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von DateiExport: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(DateiExport other){
               other.setDateiArt(this.dateiArt);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(DateiExport other){
                       if (hasChangedDateiArt) {
        other.setDateiArt(this.dateiArt);
      }
             }





    @javax.persistence.Transient
    private transient DateiExportTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public DateiExportTK getDateiExportTK(){
    if (tkCache==null) {
    tkCache = new DateiExportTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getDateiExportTK();
    }

  @Override
  public DateiExportUK getUk(){
    return getDateiExportUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return DateiExport.class;
  }

public DateiExportUK getDateiExportUK(){

   return  new DateiExportUK(



  );
}

  @javax.persistence.Transient
  private transient DateiExportProperties properties;

  public DateiExportProperties getProperties(){
    if (properties == null) {
      properties = new DateiExportProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public DateiExportProperties getDateiExportProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return DateiExportConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(DateiExportConstants.MESSAGE_KEY_DATEI_ART_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(DateiExportConstants.MESSAGE_KEY_DATEI_ART_EINZAHL);

        dateiArt =
     (de.ivu.elect.business.exchange.entity.DateiExportArt) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertDateiArt) {
      result.put(DateiExportConstants.MESSAGE_KEY_DATEI_ART_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenDateiArt , dateiArt));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertDateiArt = false;
      wertNachLadenDateiArt = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    if (datei != null) {
          if (!result.contains(datei)) {
            de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode node = new de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode(DateiExportConstants.MESSAGE_KEY_DATEI_ID_EINZAHL, datei);
            result.add(node);
            node.getChildren().addAll(datei.getFachlichAbhaengigeEntitaeten());
          }
        }
            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "DATEI_EXPORT";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "DateiExport";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

  @javax.persistence.Transient
  private transient boolean hashCodeBerechnet = false;

  @javax.persistence.Transient
  private transient int hashCode = 0;


  @Deprecated // nur in Unit-Tests verwenden(!)
  public void resetHashCode() {
    hashCodeBerechnet = false;
    hashCode = 0;
  }

  @Override
    public int hashCode() {
      if (hashCodeBerechnet) {
      return hashCode;
    }

    if (id == null) {
      hashCode = super.hashCode();
    } else {
      hashCode = id.hashCode();
    }

    hashCodeBerechnet = true;

    return hashCode;

    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(dateiArt, this, DateiExportConstants.MESSAGE_KEY_DATEI_ART_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        @Override
        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }
                              }
